(*
Copyright (C) 2000 Chris Teague
Copyright (C) 2000 Chris Millward (Chris.R.Millward@btinternet.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*)
unit ufrmAbout;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TfrmAbout = class(TForm)
    Image1: TImage;
    lblProductName: TLabel;
    lblVersion: TLabel;
    lblCopyright: TLabel;
    lblVersionCap: TLabel;
    lblCopyright1: TLabel;
    lblCopyright2: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
	frmAbout: 							TfrmAbout;
	iVersionInfoSize:	    	Cardinal;
	pVersionInfo:			    	PChar;
	iTemp:									Dword;
	pStringData:					  PChar;
	dwLen:									DWord;
	strAppName:							String;

function GetAppVersion: string;
function GetAppSystemName : string;
function GetAppCompanyName : string;
function GetAppProductName : string;
function GetAppCopyright : string;	

implementation

{$R *.DFM}

procedure GetInfoArea;
begin
  {extract application name}
	strAppName := Application.EXEName;
	{extract version information from application}
  iVersionInfoSize := GetFileVersionInfoSize(Pchar(strAppName), itemp);
  if iVersionInfoSize > 0 then
    begin
			{set buffer size}
			pVersionInfo := AllocMem(iVersionInfoSize);
      {fill buffer}
			GetFileVersionInfo(PChar(strAppName), 0, iVersionInfoSize , pVersionInfo);
		end;
end;

function GetAppVersion: string;
begin
	GetInfoArea;
  VerQueryValue(pVersionInfo, PChar('StringFileInfo\080904E4\FileVersion'), Pointer(pStringData), dwLen);
	result := pStringData;
end;

function GetAppSystemName: string;
begin
	GetInfoArea;
	VerQueryValue(pVersionInfo, PChar('StringFileInfo\080904E4\System Name'), Pointer(pStringData), dwLen);
  result := pStringData;
end;

function GetAppCompanyName: string;
begin
	GetInfoArea;
  VerQueryValue(pVersionInfo, PChar('StringFileInfo\080904E4\CompanyName'), Pointer(pStringData), dwLen);
	result := pStringData;
end;

function GetAppProductName: string;
begin
  GetInfoArea;
  VerQueryValue(pVersionInfo, PChar('StringFileInfo\080904E4\ProductName'), Pointer(pStringData), dwLen);
 	result := pStringData;
end;

function GetAppCopyright: string;
begin
	GetInfoArea;
  VerQueryValue(pVersionInfo, PChar('StringFileInfo\080904E4\LegalCopyright'), Pointer(pStringData), dwLen);
	Result := pStringData;
end;

procedure TfrmAbout.FormCreate(Sender: TObject);
begin
	lblProductName.Caption := GetAppProductName;
	lblVersion.Caption := GetAppVersion;
	lblCopyright.Caption := GetAppCopyright;
end;

end.
