(*
Copyright (C) 2000 Chris Teague
Copyright (C) 2000 Chris Millward (Chris.R.Millward@btinternet.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*)
unit ufrmDebug;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TfrmDebug = class(TForm)
    gbCPU: TGroupBox;
    lblRegAcc: TLabel;
    lblRegX: TLabel;
    lblRegY: TLabel;
    lblRegAccVal: TLabel;
    lblRegXVal: TLabel;
    lblRegYVal: TLabel;
    lblPC: TLabel;
    lblPCVal: TLabel;
    lblIR: TLabel;
    lblSR: TLabel;
    lblIRVal: TLabel;
    lblSRVal: TLabel;
    lblSP: TLabel;
    lblSPVal: TLabel;
    lblCycles: TLabel;
    lblCyclesVal: TLabel;
    lblTotalCycles: TLabel;
    lblCarry: TLabel;
    lblZero: TLabel;
    lblInterrupt: TLabel;
    lblDecimal: TLabel;
    lblBreak: TLabel;
    lblReserved: TLabel;
    lblOverflow: TLabel;
    lblNegative: TLabel;
    lblCarryVal: TLabel;
    lblZeroVal: TLabel;
    lblInterruptVal: TLabel;
    lblDecimalVal: TLabel;
    lblBreakVal: TLabel;
    lblReservedVal: TLabel;
    lblOverflowVal: TLabel;
    lblNegativeVal: TLabel;
    gbPPU: TGroupBox;
    lblPPU1: TLabel;
		lblPPU2: TLabel;
		lblPPU3: TLabel;
		lblPPU4: TLabel;
		lblPPU5: TLabel;
		lblPPU6: TLabel;
		lblPPU7: TLabel;
		lblPPU8: TLabel;
		lblScanLine: TLabel;
		lblScanLineVal: TLabel;
		pnlBottom: TPanel;
		btnClose: TButton;
    bbtnGo: TBitBtn;
    bbtnHalt: TBitBtn;
    bbtnStep: TBitBtn;
    lblAddress1: TLabel;
    lblAddress3: TLabel;
    lblAddress5: TLabel;
    lblVal1: TLabel;
    lblVal3: TLabel;
    lblVal5: TLabel;
    lblVal2: TLabel;
    lblVal4: TLabel;
    lblVal6: TLabel;
    lblAddress2: TLabel;
    lblAddress4: TLabel;
    lblAddress6: TLabel;
    bbtnGoto: TBitBtn;
    edtBreak: TEdit;
    lblGoto: TLabel;
    bbtnResetCPU: TBitBtn;
    cbUpdateDisplay: TCheckBox;
    lblAddress7: TLabel;
    lblAddress8: TLabel;
    lblVal7: TLabel;
    lblVal8: TLabel;
    lblNext: TLabel;
    lblVRAMAddress: TLabel;
    lblVRAMAddressVal: TLabel;
    lblLowROM: TLabel;
    lblHighROM: TLabel;
    lblLowVal: TLabel;
    lblHighVal: TLabel;
    lblDecodedLow: TLabel;
    lblDecodedHigh: TLabel;
		procedure btnCloseClick(Sender: TObject);
    procedure bbtnHaltClick(Sender: TObject);
    procedure bbtnGoClick(Sender: TObject);
    procedure bbtnStepClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lblVal1Click(Sender: TObject);
    procedure lblVal3Click(Sender: TObject);
    procedure lblVal5Click(Sender: TObject);
    procedure lblVal2Click(Sender: TObject);
    procedure lblVal4Click(Sender: TObject);
    procedure lblVal6Click(Sender: TObject);
    procedure bbtnGotoClick(Sender: TObject);
    procedure bbtnResetCPUClick(Sender: TObject);
    procedure lblAddress1Click(Sender: TObject);
    procedure lblAddress3Click(Sender: TObject);
    procedure lblAddress5Click(Sender: TObject);
    procedure lblAddress2Click(Sender: TObject);
    procedure lblAddress4Click(Sender: TObject);
    procedure lblAddress6Click(Sender: TObject);
    procedure lblZeroValDblClick(Sender: TObject);
		procedure lblNegativeValDblClick(Sender: TObject);
		procedure lblInterruptValDblClick(Sender: TObject);
    procedure lblDecimalValDblClick(Sender: TObject);
    procedure lblBreakValDblClick(Sender: TObject);
    procedure lblOverflowValDblClick(Sender: TObject);
    procedure lblCarryValDblClick(Sender: TObject);
    procedure lblAddress7Click(Sender: TObject);
    procedure lblAddress8Click(Sender: TObject);
    procedure cbUpdateDisplayClick(Sender: TObject);
	private
    { Private declarations }
  public
		{ Public declarations }
  end;

var
  frmDebug: TfrmDebug;

implementation

uses ufrmCMNES;

{$R *.DFM}

procedure TfrmDebug.btnCloseClick(Sender: TObject);
begin
	Self.Visible := False;
end;

procedure TfrmDebug.bbtnHaltClick(Sender: TObject);
begin
	{halt}
	frmCMNES.mnuHalt.Click;
end;

procedure TfrmDebug.bbtnGoClick(Sender: TObject);
begin
	{go}
	frmCMNES.mnuGo.Click;
end;

procedure TfrmDebug.bbtnStepClick(Sender: TObject);
begin
	{step}
	frmCMNES.ExecuteStep;
end;

procedure TfrmDebug.FormShow(Sender: TObject);
begin
	frmCMNES.UpdateDebug;
end;

procedure TfrmDebug.lblVal1Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblVal3Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblVal5Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblVal2Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblVal4Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblVal6Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.bbtnGotoClick(Sender: TObject);
begin
  frmCMNES.mnuGo.Click;
end;

procedure TfrmDebug.bbtnResetCPUClick(Sender: TObject);
begin
	frmCMNES.mnuCPUReset.Click;
	frmCMNES.UpdateDebug;
end;

procedure TfrmDebug.lblAddress1Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblAddress3Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblAddress5Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblAddress2Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblAddress4Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblAddress6Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblZeroValDblClick(Sender: TObject);
begin
	if self.caption = '1' then
		CPU.SRClearBit(SR_ZERO_FLAG)
	else
		CPU.SRSetBit(SR_ZERO_FLAG);
end;

procedure TfrmDebug.lblNegativeValDblClick(Sender: TObject);
begin
	if self.caption = '1' then
		CPU.SRClearBit(SR_NEG_FLAG)
	else
		CPU.SRSetBit(SR_NEG_FLAG);
end;

procedure TfrmDebug.lblInterruptValDblClick(Sender: TObject);
begin
	if self.caption = '1' then
	begin
		CPU.SRClearBit(SR_INTR_FLAG);
	end else
	begin
		CPU.SRSetBit(SR_INTR_FLAG);
	end;
end;

procedure TfrmDebug.lblDecimalValDblClick(Sender: TObject);
begin
	if self.caption = '1' then
	begin
		CPU.SRClearBit(SR_DECIMAL_FLAG);
	end else
	begin
		CPU.SRSetBit(SR_DECIMAL_FLAG);
	end;
end;

procedure TfrmDebug.lblBreakValDblClick(Sender: TObject);
begin
	if self.caption = '1' then
	begin
		CPU.SRClearBit(SR_BREAK_FLAG);
	end else
	begin
		CPU.SRSetBit(SR_BREAK_FLAG);
	end;
end;

procedure TfrmDebug.lblOverflowValDblClick(Sender: TObject);
begin
	if self.caption = '1' then
	begin
		CPU.SRClearBit(SR_OVERFLOW_FLAG);
	end else
	begin
		CPU.SRSetBit(SR_OVERFLOW_FLAG);
	end;
end;

procedure TfrmDebug.lblCarryValDblClick(Sender: TObject);
begin
	if Self.Caption = '1' then
	begin
		CPU.SRClearBit(SR_CARRY_FLAG);
	end else
	begin
		CPU.SRSetBit(SR_CARRY_FLAG);
	end;
end;

procedure TfrmDebug.lblAddress7Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.lblAddress8Click(Sender: TObject);
begin
	frmCMNES.ClickAddress(Sender as TLabel);
end;

procedure TfrmDebug.cbUpdateDisplayClick(Sender: TObject);
begin
	frmCMNES.UpdateDebug;
end;

end.
