(*
Copyright (C) 2000 Chris Teague
Copyright (C) 2000 Chris Millward (Chris.R.Millward@btinternet.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*)
unit ufrmMemory;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons;

type
  TfrmMemory = class(TForm)
    pnlBottom: TPanel;
    btnClose: TButton;
    pgMemory: TPageControl;
    tsROM: TTabSheet;
    btnDisplayLOWROM: TButton;
    mmoROM: TMemo;
    tsVROM: TTabSheet;
    btnDisplayVROM: TButton;
    mmoVROM: TMemo;
    tsCPURAM: TTabSheet;
    btnDisplayCPURAM: TButton;
    mmoCPURAM: TMemo;
    tsVRAM: TTabSheet;
    btnDisplayVRAM: TButton;
    mmoVRAM: TMemo;
    tsSpriteRAM: TTabSheet;
    btnDisplayPRAM: TButton;
    mmoPRAM: TMemo;
    btnDisplayHIGHROM: TButton;
    procedure btnDisplayVROMClick(Sender: TObject);
    procedure btnDisplayLOWROMClick(Sender: TObject);
    procedure btnDisplayPRAMClick(Sender: TObject);
    procedure btnDisplayCPURAMClick(Sender: TObject);
    procedure btnDisplayVRAMClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure edtBankChange(Sender: TObject);
    procedure btnDisplayHIGHROMClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
	frmMemory: TfrmMemory;

implementation

uses ufrmCMNES;

{$R *.DFM}

procedure TfrmMemory.btnDisplayVROMClick(Sender: TObject);
var
	iX:				Integer;
	strLine:	String;
	iLoc:			Word;
begin

	iLoc := 0;
	with ufrmCMNES.VROM do
	begin
		mmoVROM.Clear;
		mmoVROM.Visible := False;
		iX := 0;
		while (iX < ROMHeader.ChrSize) do
		begin
			strLine := '$' + IntToHex(iLoc,4);
			strLine := strLine + ' - ' + IntToHex(ReadByte(iX),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+1),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+2),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+3),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+4),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+5),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+6),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+7),2);
			mmoVROM.Lines.Add(strLine);
			Inc(iX,8);
			Inc(iLoc,8);
		end;
	end;
	mmoVROM.Visible := True;
end;

procedure TfrmMemory.btnDisplayLOWROMClick(Sender: TObject);
var
	iX:	Integer;
	strLine:	String;
	iLoc:			Integer;
begin
	iLoc := $8000;
	with ufrmCMNES.ROM do
	begin
		mmoROM.Clear;
		mmoROM.Visible := False;
		iX := Mapper0.DecodedLow;
		while (iX < Integer(Mapper0.DecodedLow + $4000)) do
		begin
			strLine := '$' + IntToHex(iLoc,4) + ' - ';
			strLine := strLine + IntToHex(ReadByte(iX),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+1),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+2),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+3),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+4),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+5),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+6),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+7),2);
			mmoROM.Lines.Add(strLine);
			Inc(iX,8);
			Inc(iLoc,8);
		end;
	end;
	mmoROM.Visible := True;

end;

procedure TfrmMemory.btnDisplayPRAMClick(Sender: TObject);
var
	iX:	Integer;
	strLine:	String;
	iLoc:			Integer;
begin
	iLoc := 0;
	with ufrmCMNES.PPU do
	begin
		mmoPRAM.Clear;
		mmoPRAM.Visible := False;
		iX := 0;
		while (iX < 256) do
		begin
			strLine := '$' + IntToHex(iLoc,4) + ' - ';
			strLine := strLine + IntToHex(SpriteRam[iX],2);
			strLine := strLine + ' ' + IntToHex(SpriteRam[iX+1],2);
			strLine := strLine + ' ' + IntToHex(SpriteRam[iX+2],2);
			strLine := strLine + ' ' + IntToHex(SpriteRam[iX+3],2);
			strLine := strLine + ' ' + IntToHex(SpriteRam[iX+4],2);
			strLine := strLine + ' ' + IntToHex(SpriteRam[iX+5],2);
			strLine := strLine + ' ' + IntToHex(SpriteRam[iX+6],2);
			strLine := strLine + ' ' + IntToHex(SpriteRam[iX+7],2);
			mmoPRAM.Lines.Add(strLine);
			Inc(iX,8);
			Inc(iLoc,8);
		end;
	end;
	mmoPRAM.Visible := True;

end;

procedure TfrmMemory.btnDisplayCPURAMClick(Sender: TObject);
var
	iX:				Integer;
	strLine:	String;
	iLoc:			Word;
begin
	iLoc := 0;
	with ufrmCMNES.IRAM do
	begin
		mmoCPURAM.Clear;
		mmoCPURAM.Visible := False;
		iX := 0;
		while (iX < 2048) do
		begin
			strLine := '$' + IntToHex(iLoc,4);
			strLine := strLine + ' - ' + IntToHex(ReadByte(iX),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+1),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+2),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+3),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+4),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+5),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+6),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+7),2);
			mmoCPURAM.Lines.Add(strLine);
			Inc(iX,8);
			Inc(iLoc,8);
		end;
	end;
	mmoCPURAM.Visible := True;

end;

procedure TfrmMemory.btnDisplayVRAMClick(Sender: TObject);
var
	iX:				Integer;
	strLine:	String;
	iLoc:			Word;
begin
	iLoc := $2000;
	with ufrmCMNES.VRAM do
	begin
		mmoVRAM.Clear;
		mmoVRAM.Visible := False;
		iX := 0;
		while (iX < 2048) do
		begin
			strLine := '$' + IntToHex(iLoc,4);
			strLine := strLine + ' - ' + IntToHex(ReadByte(iX),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+1),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+2),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+3),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+4),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+5),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+6),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+7),2);
			mmoVRAM.Lines.Add(strLine);
			Inc(iX,8);
			Inc(iLoc,8);
		end;
	end;
	mmoVRAM.Visible := True;

end;

procedure TfrmMemory.btnCloseClick(Sender: TObject);
begin
	Close;
end;

procedure TfrmMemory.edtBankChange(Sender: TObject);
begin
	{}
end;

procedure TfrmMemory.btnDisplayHIGHROMClick(Sender: TObject);
var
	iX:	Integer;
	strLine:	String;
	iLoc:			Integer;
begin
	iLoc := $C000;
	with ufrmCMNES.ROM do
	begin
		mmoROM.Clear;
		mmoROM.Visible := False;
		iX := Mapper0.DecodedHigh;
		while (iX < Integer(Mapper0.DecodedHigh + $4000)) do
		begin
			strLine := '$' + IntToHex(iLoc,4) + ' - ';
			strLine := strLine + IntToHex(ReadByte(iX),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+1),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+2),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+3),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+4),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+5),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+6),2);
			strLine := strLine + ' ' + IntToHex(ReadByte(iX+7),2);
			mmoROM.Lines.Add(strLine);
			Inc(iX,8);
			Inc(iLoc,8);
		end;
	end;
	mmoROM.Visible := True;

end;

end.
