(*
Copyright (C) 2000 Chris Teague
Copyright (C) 2000 Chris Millward (Chris.R.Millward@btinternet.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*)
unit ufrmSettings;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TfrmSettings = class(TForm)
    pnlBottom: TPanel;
    btnOK: TButton;
    btnCancel: TButton;
    pgSettings: TPageControl;
    tsVideo: TTabSheet;
    tsSound: TTabSheet;
    tsControllers: TTabSheet;
    gbType: TGroupBox;
    rbPAL: TRadioButton;
    rbNTSC: TRadioButton;
    tsDirectories: TTabSheet;
    lblROMS: TLabel;
    lblScreenShots: TLabel;
    lblSoundCaptures: TLabel;
    edtROMPath: TEdit;
    edtScreenCapturePath: TEdit;
    edtSoundCapturePath: TEdit;
    cbPalette: TComboBox;
    lblPalette: TLabel;
    gbController1: TGroupBox;
    imgLeft1: TImage;
    imgUp1: TImage;
    imgRight1: TImage;
    imgDown1: TImage;
    gbController2: TGroupBox;
    imgLeft2: TImage;
    imgUp2: TImage;
    imgRight2: TImage;
    imgDown2: TImage;
    lblUp1: TLabel;
    lblLeft1: TLabel;
    lblRight1: TLabel;
    lblDown1: TLabel;
    shpButton11: TShape;
    shpButton12: TShape;
    lblButton11: TLabel;
    lblButton12: TLabel;
    gbFrameSkip: TGroupBox;
    rbfsNone: TRadioButton;
    rbfs25: TRadioButton;
    rbfs50: TRadioButton;
    rbfs75: TRadioButton;
    rbfs33: TRadioButton;
    shpButton21: TShape;
    shpButton22: TShape;
    lblUp2: TLabel;
    lblDown2: TLabel;
    lblLeft2: TLabel;
    lblRight2: TLabel;
    lblButton21: TLabel;
    lblButton22: TLabel;
    lblSelect1: TLabel;
    lblSelect1Val: TLabel;
    lblStart1: TLabel;
    lblStart1Val: TLabel;
    lblSelect2: TLabel;
    lblStart2: TLabel;
    lblSelect2Val: TLabel;
    lblStart2Val: TLabel;
    gbDisplayMode: TGroupBox;
    rb320: TRadioButton;
    rb640: TRadioButton;
    UpDown1: TUpDown;
    edtPoll: TEdit;
    Label1: TLabel;
    cbForceFeedback: TCheckBox;
    procedure btnOKClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rbfsNoneClick(Sender: TObject);
		procedure edtPollChange(Sender: TObject);
	private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSettings: TfrmSettings;

implementation

uses ufrmCMNES;

{$R *.DFM}

procedure TfrmSettings.btnOKClick(Sender: TObject);
begin
	{pass settings}
	ufrmCMNES.strROMPath := edtROMPath.Text;
	ufrmCMNES.strScreenCapturePath := edtScreenCapturePath.Text;
	ufrmCMNES.strSoundCapturePath := edtSoundCapturePath.Text;
	Close;
end;

procedure TfrmSettings.btnCancelClick(Sender: TObject);
begin
	Close;
end;

procedure TfrmSettings.FormCreate(Sender: TObject);
begin
	{populate with settings from registry}
	
	{directories}
	edtROMPath.Text := ufrmCMNES.strROMPath;
	edtScreenCapturePath.Text := ufrmCMNES.strScreenCapturePath;
	edtSoundCapturePath.Text := ufrmCMNES.strSoundCapturePath;
end;

procedure TfrmSettings.rbfsNoneClick(Sender: TObject);
begin
	frmCMNES.SetFrameSkip;
end;


procedure TfrmSettings.edtPollChange(Sender: TObject);
begin
	frmCMNES.tmrDIPoll.Interval := StrToInt(edtPoll.text);
end;

end.
